#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Sep 14 10:15:29 2021

@author: frederic
"""
import tkinter as tk
import simulation_ecologie as simul
from time import time, sleep

class HerbeMoutonLoupGUI:
    
    def __init__(self):
        self.fenetre = tk.Tk()
        self.fenetre.title('Système ulti-agents : simulation écologique')
        self.fenetre.configure(background='white')
        largeur_ecran = self.fenetre.winfo_screenwidth()
        hauteur_ecran = self.fenetre.winfo_screenheight()
        min_h_l = min(largeur_ecran, hauteur_ecran)
    
        # Les éléméents de la fenêtre
        self.dim_cell = min_h_l // 100         # suppose que la dimension du monde soit 50 !!!
        self.dim_cell = max(self.dim_cell, 5)
        h_canevas = self.dim_cell * 50
        l_canevas = h_canevas
        
        self.can = tk.Canvas(self.fenetre, bg='white', width = l_canevas, 
                 height = h_canevas, highlightthickness=5)
        self.can.grid(row = 0, column = 0, columnspan = 20)
        self.label_fin =tk.Label(self.fenetre, text = "", padx = 2, pady = 2)
        self.label_fin.grid(row = 1, column = 1)
        self.bouton_un_tour = tk.Button(self.fenetre, text="Un seul tour ", 
                                          command = lambda : self.unTour())
        self.bouton_un_tour.grid(row = 2, column = 0, pady = 3)
        self.bouton_complet = tk.Button(self.fenetre, text="Simulation complète ", 
                                          command = lambda : self.simulTout())
        self.bouton_complet.grid(row = 2, column = 3, pady = 3)
        self.bouton_quitter = tk.Button(self.fenetre, text="Quitter", command = self.fenetre.destroy)
        self.bouton_quitter.grid(row = 2, column = 6, pady = 5)
        
        self.simulation = simul.Simulation()
        self.dim = self.simulation.monde.dimension

        
        # Initialisation du canevas
        self.carres_carte = []
        for i in range(self.dim) :
            ligne = []
            for j in range(self.dim) :
                if self.simulation.monde.bonManger(i, j)  :
                    couleur = "spring green"
                else :
                    couleur = "burlywood4"
                rect = self.can.create_rectangle(i*self.dim_cell, j*self.dim_cell, 
                                          (i + 1)*self.dim_cell, (j + 1)*self.dim_cell, 
                                          fill = couleur, outline = couleur)
                ligne.append(rect)
            self.carres_carte.append(ligne) 
        
        self.moutons_dessin = []
        for m in self.simulation.moutons :
            x = m.position[0]
            y = m.position[1]
            beeh = self.can.create_oval(x*self.dim_cell + 1, y*self.dim_cell + 1, 
                                          (x + 1)*self.dim_cell - 1, (y + 1)*self.dim_cell - 1, 
                                          fill = "white", outline = "white")
            self.moutons_dessin.append(beeh)
        self.les_moutons = [self.simulation.moutons, self.moutons_dessin]
        
        self.loups_dessin = []
        for w in self.simulation.loups :
            x = w.position[0]
            y = w.position[1]
            grr = self.can.create_oval(x*self.dim_cell + 1, y*self.dim_cell + 1, 
                                          (x + 1)*self.dim_cell - 1, (y + 1)*self.dim_cell - 1, 
                                          fill = "dark slate grey", outline = "dark slate grey")
            self.loups_dessin.append(grr)
        self.les_loups = [self.simulation.loups, self.loups_dessin]
    
        self.fenetre.mainloop()
        
    def maj(self, monde, moutons, loups):
        for i in range(self.dim) :
            for j in range(self.dim) :
                if self.simulation.monde.bonManger(i, j) :
                    couleur = "spring green"
                else :
                    couleur = "burlywood4"
                identifiant = self.carres_carte[i][j]
                self.can.itemconfig(identifiant, fill = couleur, outline = couleur)
        
        for cercle in self.moutons_dessin:
            self.can.delete(cercle)
        """
        #self.moutons_dessin = []
        for i in range(len(self.les_moutons)) :           
            m_logique = self.les_moutons[0][i]
            m_dessin = self.les_moutons[1][i]
            print(m_logique, m_dessin)
            x = m_logique.position[0]
            y = m_logique.position[1]
            if m_logique in moutons :
                self.can.move(m_dessin, 1, 0)
            beeh = self.can.create_oval(x*self.dim_cell + 1, y*self.dim_cell + 1, 
                                          (x + 1)*self.dim_cell - 1, (y + 1)*self.dim_cell - 1, 
                                          fill = "white", outline = "white")
        """
        self.moutons_dessin = []
        for m in self.simulation.moutons :
            x = m.position[0]
            y = m.position[1]
            beeh = self.can.create_oval(x*self.dim_cell + 1, y*self.dim_cell + 1, 
                                          (x + 1)*self.dim_cell - 1, (y + 1)*self.dim_cell - 1, 
                                          fill = "white", outline = "white")
            self.moutons_dessin.append(beeh)
        self.les_moutons = [self.simulation.moutons, self.moutons_dessin]
        
        for cercle in self.loups_dessin:
            self.can.delete(cercle)
        self.loups_dessin = []
        for w in self.simulation.loups :
            x = w.position[0]
            y = w.position[1]
            grr = self.can.create_oval(x*self.dim_cell + 1, y*self.dim_cell + 1, 
                                          (x + 1)*self.dim_cell - 1, (y + 1)*self.dim_cell - 1, 
                                          fill = "dark slate grey", outline = "dark slate grey")
            self.loups_dessin.append(grr)
        self.can.update()
        self.can.after(500)
            
    def unTour(self):
        monde, moutons, loups, horloge = self.simulation.simMoutonGUITour()
        if horloge <= self.simulation.fin_du_monde :
            self.maj(monde, moutons, loups)
        else :
            self.label_fin.configure(text = "Fin de la simulation", 
                                        borderwidth=1, relief="raised", )  
            self.label_fin.update()
     
    def simulTout(self):
        print("ici")
        for i in range(self.simulation.fin_du_monde) :
            self.unTour()
            print("après le tour : ", self.simulation.horloge)

# Programme principal
def main():
    gui = HerbeMoutonLoupGUI()

if __name__ == '__main__':
    main()